
/*-
 * All UZI280 source code is 
 * (c) Copyright (1990-95) by Stefan Nitschke and Doug Braun.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that: (1) source distributions retain this entire copyright
 * notice and comment, (2) it is not used for military purpose in
 * any form, (3) it is not used for any commercial purpose, and (4) 
 * distributions including binaries display the following acknowledgement:
 * ``This product includes software developed by Stefan Nitschke 
 *   and his contributors''
 * in the documentation or other materials provided with the distribution
 * and in all advertising materials mentioning features or use of this
 * software. Neither the name of the author nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#asm

*Include	macro.lib
		
	global	_bzero

	psect	text
_bzero:
	LDHLSX	4 	; count
;	;cpw	127
;			defb	0fdh,0edh,0f7h
;			defw	127	
;	jr	nc,dma	; more than 127 bytes -> use dma0
	dec	hl
	ld	b,h
	ld	c,l
	LDHLSX	2	
	ld	d,h	
	ld	e,l	; ptr hl -> de 
	inc	de
	ld	(hl),0
	ldir
	ret
#endasm

#ifdef DMA_bzero
#asm
	global	dodma
dma:
	ld	(length),hl	; save length
	LDHLSX	2
	ld	(dest),hl
	ld	l,h		; get bit 15-12 into l
	ld	h,081h 		; system memory high bits (23-16)
	ld	(dest+2),hl
	ld	hl,zero
	ld	(source),hl
	ld	l,h
	ld	h,081h
	ld	(source+2),hl
	ld	A,0h	;use DMA0
	LD	HL,dest
	call	dodma
	ret

	psect	data

dest:	DEFW	0000
	DEFW	0000
source:	DEFW	0000	
	DEFW	0000	
length:	DEFW	0000	 	;length in 8-bit words
desc:	DEFW	0A100H		;continous, memory -> memory++, 8-bit
zero:	defb	0

	psect	text
#endasm
#endif
