
/*-
 * All UZI280 source code is 
 * (c) Copyright (1990-95) by Stefan Nitschke and Doug Braun.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that: (1) source distributions retain this entire copyright
 * notice and comment, (2) it is not used for military purpose in
 * any form, (3) it is not used for any commercial purpose, and (4) 
 * distributions including binaries display the following acknowledgement:
 * ``This product includes software developed by Stefan Nitschke 
 *   and his contributors''
 * in the documentation or other materials provided with the distribution
 * and in all advertising materials mentioning features or use of this
 * software. Neither the name of the author nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#asm 
 	psect	text

 	global	_dma_write, _dma_read	
 	global	_lowadr,_highadr,_dptrlo,_dptrhi
 	global	_iopgff,_iopg00,_rw_flag
  
 	psect	data
_highadr:	defw	0
_lowadr:	defw	0
	psect	text

_dma_write:
	push	bc
 	ld	hl,(_lowadr)
 	ld	(hddest),hl	
 	ld	hl,(_highadr)
 	ld	(hddest+2),hl		; Destination Adr
        ld      hl,(_dptrlo)
 	ld	(hdsource),hl
        ld      hl,(_dptrhi)
 	ld	(hdsource+2),hl		; Source Adr
01:	ld	a,(_rw_flag)
	or	a
	jr	nz,01b			; wait for last hard disc write ready
 	jp	dma0		        ; Start DMA Transfer
 
_dma_read:
	push	bc
        ld      hl,(_dptrlo)
 	ld	(hddest),hl
        ld      hl,(_dptrhi)
 	ld	(hddest+2),hl		; Destination Adr
 	ld	hl,(_lowadr)
 	ld	(hdsource),hl	
 	ld	hl,(_highadr)
 	ld	(hdsource+2),hl		; Source Adr
 ;	jp	dma0		        ; Start DMA Transfer
 
;----------------------------------
; Setup DMA2 for mem copy
;----------------------------------
dma0:			
;DMA2 init --> transfer
        call    _iopgff
 	ld	c,0h		; Adresse DMA-Register (DMA2)
 	ld      hl,hddest
        ld      b,6		
 	;outiw			
1:	defb	0edh,83h
 	inc	c		
        inc     b
        dec     b
        jr      nz,1b
        call    _iopg00
	pop	bc
 	ret			
 
;------------------------------
; Variablen Feld f}r die DMA2
;------------------------------ 
 	psect	data
 
hddest:		defw	0
 		defw	0	
hdsource:	defw	0
 		defw	0	
dmacnt:		defw	512	; length: 512 Byte 
hddescr:	defw	8100h	;continuous, memory++, 8 bit
		;defw	8000h	;single, memory++, 8 bit
	psect	text
#endasm 
